package Generics;

import java.util.ArrayList;
import java.util.Random;
import Entities.*;
import Drawnings.*;

public class GenericParametrized<T extends EntityAirbus, U extends IDrawningPortholes> {

    private ArrayList<T> _airbus;
    private ArrayList<U> _portholes;
    private int CountAirbus;
    private int CountPortholes;
    private int MaxCountAirbus;
    private int MaxCountPortoles;
    private int _pictureWidth;
    private int _pictureHeight;

    public GenericParametrized(int maxCountAirbus, int maxCountPortoles, int pictureWidth, int pictureHeight)
    {
        MaxCountAirbus = maxCountAirbus;
        CountAirbus = 0;
        MaxCountPortoles = maxCountPortoles;
        CountPortholes = 0;
        _pictureWidth = pictureWidth;
        _pictureHeight = pictureHeight;
    }

    public boolean addAirbus(T airbus)
    {
        if (airbus == null || CountAirbus >= MaxCountAirbus)
            return false;
        _airbus.add(airbus);
        CountAirbus++;
        return true;
    }

    public boolean addPortholes(U porthole)
    {
        if (porthole == null || CountPortholes >= MaxCountPortoles)
            return false;
        _portholes.add(porthole);
        CountPortholes++;
        return true;
    }

    public DrawningAirbus randomDrawingObject()
    {
        Random rand = new Random();
        if (CountAirbus == 0 || CountPortholes == 0)
            return null;
        int ar = rand.nextInt(CountAirbus);
        int port = rand.nextInt(CountPortholes);
        DrawningAirbus drawningAirbus;
        if (_airbus.get(ar) instanceof EntityAirbus)
            drawningAirbus = new DrawningAirbus(
                    _airbus.get(ar).getSpeed(),
                    _airbus.get(ar).getWeight(),
                    _airbus.get(ar).getBodyColor(),
                    _portholes.get(port).getCount(),
                    _pictureWidth, _pictureHeight);
        else
            drawningAirbus = new DrawningPlane(
                    _airbus.get(ar).getSpeed(),
                    _airbus.get(ar).getWeight(),
                    _airbus.get(ar).getBodyColor(),
                    _portholes.get(port).getCount(),
                    ((EntityPlane)_airbus.get(ar)).getAdditionalColor(),
                    ((EntityPlane)_airbus.get(ar)).IsCompartment(),
                    ((EntityPlane)_airbus.get(ar)).IsAdditionalEngine(),
                    _pictureWidth, _pictureHeight);
        return drawningAirbus;
    }
}
