package Generics;

public class SetGeneric<T extends Object> {

    // список объектов
    private Object[] _places;
    // кол-во объектов
    public int Count;

    public SetGeneric(int count)
    {
        _places = new Object[count];
        Count = _places.length;
    }

    // Добавление объекта в набор
    public int Insert(T airbus)
    {
        return Insert(airbus, 0);
    }

    // Добавление объекта в набор на конкретную позицию
    public int Insert(T airbus, int position)
    {
        if (position < 0 || position >= Count)
        {
            return -1;
        }
        int pos = position;
        if (_places[position] != null) {
            for (int i = position + 1; i < Count; ++i) {
                if (_places[i] == null) {
                    pos = i;
                    break;
                }
            }
            if (pos == Count-1)
                return -1;
            for (int i = pos; i > position; --i) {
                _places[i] = _places[i - 1];
            }
        }
        _places[position] = airbus;
        return position;
    }

    // Удаление объекта из набора с конкретной позиции
    public boolean Remove(int position)
    {
        if (position < 0 || position >= Count)
        {
            return false;
        }
        _places[position] = null;
        return true;
    }

    // Получение объекта из набора по позиции
    public T Get(int position)
    {
        if (position < 0 || position >= Count)
        {
            return null;
        }
        return (T)_places[position];
    }
}
